import { useState, useEffect } from 'react'
import { timeFormat } from 'd3'

const jsonUrl = 'https://gist.githubusercontent.com/KMSkelton/7770ad345b8b8140e8385e5c593efb86/raw/23ccae7145b8192f18a4571c1f1bb3d4730f12be/sleep-2020-08-22.json'
const formatTime = timeFormat("%H")

const fetchData = async(url, innerHeight) => {
  const response = await fetch(url)
  const data = await response.json()
  const hourHeight = innerHeight / 18
  console.log(innerHeight)
  data.map(d => {
    const endHour = d.endTime.split("T")[1]
    d['endHour'] = +endHour.split(":")[0] + +(endHour.split(":")[1]/60).toFixed(4)
    d['endHeight'] = d['endHour'] * hourHeight
    d['decHoursAsleep'] = +(d['minutesAsleep']/60).toFixed(4)
    d['calendarDayNumberOfSleep'] = +d['dateOfSleep'].split("-")[2]
    d['calendarYearNumberOfSleep'] = +d['dateOfSleep'].split("-")[0]
    d['calendarMonthNumberOfSleep'] = +d['dateOfSleep'].split("-")[1]
    d['moonPhase'] = Simple(d['calendarYearNumberOfSleep'], d['calendarMonthNumberOfSleep'], d['calendarDayNumberOfSleep'])
  })
	data.sort((a,b) => (a.moonPhase > b.moonPhase) ? 1 : -1)
  return data
}

function Simple(year,month,day)
{
	var lp = 2551443; 
	var now = new Date(year,month-1,day,20,35,0);						
	var new_moon = new Date(1970, 0, 7, 20, 35, 0);
	var phase = ((now.getTime() - new_moon.getTime())/1000) % lp;
	return Math.floor(phase /(24*3600)) + 1;
}
export const sleepData = (innerHeight) => {
  const [data, setData] = useState() 
	
    useEffect(() => {
  	fetchData(jsonUrl, innerHeight)
      .then(data => setData(data))
  }, [])
  return data
}

